/*
	$Id: memory.cpp,v 1.1.1.1 1998/12/20 23:33:18 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#define NO_MEMORYDEBUG

#include <iostream.h>
#include <stdlib.h>
#include <new.h>

#ifdef ENABLE_MEMORYDEBUG

CL_List<CL_MemoryEntry> CL_MemManager::entries;
char *CL_MemManager::temp_file = NULL;
int CL_MemManager::temp_line;
bool CL_MemManager::enabled = false;

bool pass_through = false;

void *operator new(size_t size)
{
	void *p = malloc(size);
	
	if (pass_through == false)
	{
		pass_through = true;
		CL_MemManager::mark_new(p, size);
		pass_through = false;
	}

	return p;
}

void operator delete(void *p)
{
	if (pass_through == false)
	{
		pass_through = true;
		CL_MemManager::mark_delete(p);
		pass_through = false;
	}

	free(p);
}

void operator delete[](void *p)
{
	if (pass_through == false)
	{
		pass_through = true;
		CL_MemManager::mark_delete(p);
		pass_through = false;
	}

	free(p);
}

#endif
