#!/usr/bin/perl
#
# The ClanSoft Web builder script
# Copyright (c)1998 ClanSoft.
#

use English;

$ARGV[0] =~ /^(.*).txt$/;
$output = "$1.html";

$image_path = "http://dark.x.dtu.dk/clansoft/gfx";
$eye_color = "green";

$news_begin = "<center><table width=90%>";
$news_end = "</table></center>";
$news_s1 = "<tr bgcolor=#eeeeee><td align=left valign=top>";
$news_s2 = "</td></tr>";

$news =
	$news_begin.
	$news_s1.
	'<p>Date: <b>16 Oct</b>. Author: <a href="mailto:mbn@dark.x.dtu.dk">Magnus Norddahl</a></p>'.
	"<p>Uploaded ClanLib 0.1.9 to our website. This new version includes a ".
	"lot of bug fixes. A standalone X11 impl has been written - Mesa is no ".
	"longer needed.</p>".
	"<p>Anonymous cvs checkouts are now available. Read the download page ".
	"for more information.</p>".
	$news_s2.
	$news_end;

open(INPUT, $ARGV[0]) || die;
open(OUTPUT, ">$output") || die;
read_header();
read_body();
close(INPUT);
close(OUTPUT);

sub read_header()
{
	my $title = "nonamed page";

	my $line = <INPUT>;
	chop $line;
	
	while ($line ne "body:")
	{
		if ($line =~ /^(.+?): (.*)/)
		{
			my $command = $1;
			my $param = $2;
			
			$title = $param if ($command eq "title");
			$eye_color = $param if ($command eq "eyecolor");
		}
	
		$line = <INPUT>;
		die "No body: found!!" if (!$line);
		chop $line;
	}
	
	print OUTPUT "<html><head><title>$title</title></head>\n";
	print OUTPUT "<body text=black link=blue vlink=#800080 bgcolor=white topmargin=0 leftmargin=0>\n\n";

	print OUTPUT "<table border=0 cellspacing=0 cellpadding=0 width=100%>\n";
	print OUTPUT "<tr><td align=left valign=top><img border=0 ".
		"src=\"$image_path/eyeheader-main-$eye_color-a.gif\" alt=\"ClanSoft logo\" width=525 height=96></td></tr>\n";
	print OUTPUT "<tr bgcolor=#dadada><td align=left valign=top><img border=0 ".
		"src=\"$image_path/eyeheader-main-$eye_color-b.gif\" alt=\"ClanSoft logo\" width=190 height=14></td>\n";
	print OUTPUT "<td align=right valign=top><img border=0 ".
		"src=\"$image_path/clanlib_light.gif\" width=42 height=14></td></tr>\n";
	print OUTPUT "</table>\n\n\n";
	
	print OUTPUT "<center><br><table width=90%><tr><td>\n";
	print OUTPUT "<ul><h1>$title</h1></ul>\n\n";
}

sub read_body()
{
	my $line;

	my $code_mode = 0;

	while (($line = <INPUT>))
	{
		if ($code_mode == 0)
		{
			$line =~ s/<h>/<h2>/g;
			$line =~ s/<\/h>/<\/h2>/g;
			$line =~ s/<news>/$news/g;
			$line =~ s/<menu>/<ul>/g;
			$line =~ s/<\/menu>/<\/ul>/g;
			$line =~ s/<menuitem \"(.*?)\" \"(.*?)\" \"(.*?)\">/<li><a href=\"$1.html\">$2<\/a><br>\n<ul>$3<\/ul><br>/g;
			$line =~ s/<link \"(.+?)\">/<a href=\"$1\.html\">/g;
			$line =~ s/<\/link>/<\/a>/g;
			$line =~ s/<image \"(.*?)\" \"(.*?)\">/<img src=\"$image_path\/$1\" alt=\"$2\">/g;
			$line =~ s/<download_menu>/<ul>/g;
			$line =~ s/<\/download_menu>/<\/ul>/g;
			$line =~ s/<download \"(.*?)\" \"(.*?)\">/<li><a href=\"$1\">$1<\/a>\n<ul>$2<\/ul><br>/g;
			$line =~ s/<version>/0.1.9/g;
			$line =~ s/<version_devel>/0.1.10/g;

			$code_mode = 1 if ($line =~ /<code>/);

			$line =~ s/<code>/<ul><pre>/g;
		}
		else
		{
			if ($line =~ /<\/code>/)
			{
				$code_mode = 0;
				$line =~ s/<\/code>/<\/pre><\/ul>/g;
			}
			else
			{
				$line =~ s/</&lt;/g;
			}
		}
	
		print OUTPUT $line;
	}


	print OUTPUT "</td></tr></table>\n";
	print OUTPUT "<br><br><font color=#a0a0a0>This page was generated with the ClanSoft WebBuilder Perl script</font><br>\n";
	print OUTPUT "</body></html>\n";
}

