/*
	$Id: vidmode.h,v 1.8 1999/07/21 22:56:09 vogel Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l1_component="Display 2D"

#ifndef header_vidmode
#define header_vidmode

#include "../../../Common/clanstring.h"

class CL_VidMode
//: Video mode class. 
// This class is used to describe a videomode in ClanLib.
{
public:
	int width;
	//: Videomode width.

	int height;
	//: Videomode height.

	int bpp;
	//: Videomode depth.

	bool mode_x;
	//: True if modeX.

	CL_VidMode(int width, int height, int bpp, bool mode_x=false)
	{
		this->width = width;
		this->height = height;
		this->bpp = bpp;
		this->mode_x = mode_x;
	}
	//: Class Constructor.
	//
	//!param: width - Width of the videomode.
	//!param: height - Height of the videomode.
	//!param: bpp - Depth (8, 16, 24, 32 bpp) of the videomode.
	//!param: mode_x - Use mode x if available.

	CL_String asString()
	{
		CL_String ret;
		ret << width << " x " << height << " - " << bpp << " bits pr. pixel";
		if (mode_x == true) ret << " (modeX)";
		return ret;
	}
	//: Converts the video mode description to a string.
	//!retval: A string describing the video mode in human language!
};

#endif
