#ifndef header_blit_dx
#define header_blit_dx

#include "../Generic/blitters.h"
#include "displaycard_dx.h"

class CL_Blit_AlphaMask_RLE;

class CL_Blit_DX :
	public CL_Blit_NoClip,
	public CL_Blit_Clip,
	public CL_Blit_Scale_NoClip,
	public CL_Blit_Scale_Clip
{
public:
	CL_Blit_DX(CL_DisplayCard_DX *target, CL_SurfaceProvider *provider);
	virtual ~CL_Blit_DX();

	bool init_surface(CL_Blitters *blitters);

	virtual void blt_noclip(
		CL_Target *target,
		int x,
		int y,
		int spr_no);

	virtual void blt_clip(
		CL_Target *target,
		int x,
		int y,
		int spr_no,
		const CL_ClipRect &clip);
	
	virtual void blt_scale_noclip(
		CL_Target *target,
		int x,
		int y,
		int dest_width,
		int dest_height,
		int spr_no);

	virtual void blt_scale_clip(
		CL_Target *target,
		int x,
		int y,
		int dest_width,
		int dest_height,
		int spr_no,
		const CL_ClipRect &clip);

	static void reload_all_surfaces();

private:
	CL_DisplayCard_DX *m_target;
	CL_SurfaceProvider *m_provider;
	bool m_transparent;
	unsigned int m_width, m_height;

	CL_Blit_AlphaMask_RLE *m_alphablitter;

	LPDIRECTDRAWSURFACE m_surface;

	bool reload(bool lock_provider, bool create_surface);

	static CL_List<CL_Blit_DX> m_loaded_surfaces;
};

#endif