/*
	$Id: display_dx.cpp,v 1.5 1999/03/12 03:48:42 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include <iostream.h>
#include <stdlib.h>
#include "Layer1/System/API/cl_assert.h"
#include "display_dx.h"
#include "displaycard_dx.h"
#include "Layer1/System/Win32/app_windows.h"

CL_DisplayCard_DX *CL_Display_DX::cur_card = NULL;

struct CL_CardDescription_DX
{
	LPGUID guid;
	CL_String card_name;
};

BOOL WINAPI lpCallback(GUID FAR * lpGUID,
		LPSTR lpDriverDescription, LPSTR lpDriverName,
		LPVOID lpContext)
{
	if (lpGUID!=NULL)
	{
		CL_CardDescription_DX *ddguid = new CL_CardDescription_DX;
		ddguid->guid = new GUID;
		memcpy(ddguid->guid, lpGUID, sizeof(GUID));
		ddguid->card_name = lpDriverName;
		((CL_List<CL_CardDescription_DX> *) lpContext)->add(ddguid);
	}
	return DDENUMRET_OK;
}

CL_Display_DX::CL_Display_DX(int options)
{
	HRESULT err;

	CL_List<CL_CardDescription_DX> guids;
	err=DirectDrawEnumerate(lpCallback, &guids);
	cl_assert(err == DD_OK);

	CL_Display::num_cards = guids.get_num_items()+1;
	cout << "ClanLib: Number of display cards: " << CL_Display::num_cards << endl;
	int card_no=0;
	CL_Display::cards.add(new CL_DisplayCard_DX(card_no++, NULL, "Default Display Driver", options));
	
	for (int i=1;i<guids.get_num_items()+1;i++)
	{
		CL_Display::cards.add(new CL_DisplayCard_DX(card_no++, guids[i-1]->guid, guids[i-1]->card_name, options));
		delete guids[i-1]->guid;
		delete guids[i-1];
	}

	CL_Display_DX::cur_card = (CL_DisplayCard_DX *) CL_Display::cards[0];
}

CL_Display_DX::~CL_Display_DX()
{
	for (int i=0;i<CL_Display::num_cards;i++)
	{
		delete CL_Display::cards[i];
	}
}

void CL_Display::select_card(CL_DisplayCard *card)
{
	CL_Display_DX::cur_card = (CL_DisplayCard_DX*) card;
}

CL_DisplayCard *CL_Display::get_current_card()
{
	return CL_Display_DX::cur_card;
}
