/*
	$Id: displaycard_glx.h,v 1.6 1999/09/04 14:12:27 vogel Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_displaycard_glx
#define header_displaycard_glx

#ifdef USE_OPENGL

#include "../X11/display_xwindow.h"
#include "../Generic/GL/displaycard_gl_generic.h"
#include <GL/glx.h>
#include <iostream.h>

class CL_GLX_DisplayCard : public CL_GL_DisplayCard_Generic
{
public:
	CL_GLX_DisplayCard(
		Display *dpy,
		Window root,
		int card_no);

	virtual ~CL_GLX_DisplayCard();

	// CL_XWindow_CompatibleCard:
	// --------------------------
	
	virtual Window get_window() { return win; }
	virtual Display *get_dpy() { return dpy; }

	// CL_GL_DisplayCard_Generic
	// -------------------------
	
	virtual int get_max_texture_size() { return max_texture_size; }

	// CL_DisplayCard functions:
	// -------------------------

	virtual void flip_display(bool sync=false);
	virtual void set_videomode(int width, int height, int bpp);

	virtual CL_String get_name() { return "GLX Display"; }
	
private:
	bool initialized;
	
	Window root;
	Window win;
	Display *dpy;

	GLXContext ctx;

	GLint max_texture_size;
};

#endif

#endif
