/*
	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/


#include "blit_transparent_mmx.h"


CL_Blit_Transparent_MMX::CL_Blit_Transparent_MMX(
	CL_SurfaceProvider *provider,
	int bytes_per_pixel)
{
	width = provider->get_width();
	height = provider->get_height();
	no_sprs = provider->get_no_sprs();

	this->bytes_per_pixel = bytes_per_pixel;

	if (width % 8 == 0)
		bytes_per_line = width * (bytes_per_pixel + 1);
	else
		bytes_per_line = (width + 8 - width % 8) * (bytes_per_pixel +1);
			
	image = new double [height*no_sprs*bytes_per_line/8];
}


CL_Blit_Transparent_MMX::~CL_Blit_Transparent_MMX()
{
   	delete[] image;
}
