/*
	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_blit_transparent_rle_32
#define header_blit_transparent_rle_32

#include "blit_transparent_rle.h"
#include "../API/target.h"

class CL_Blit_Transparent_RLE_32 :
	public CL_Blit_Transparent_RLE
{

protected:

	unsigned char *make_rle_line(unsigned char *src_line, unsigned char *alpha_line);
	void blt_line(unsigned char *s, unsigned char *d);

public:  
	
	CL_Blit_Transparent_RLE_32(
		CL_SurfaceProvider *provider,
                int _bytes_per_pixel,
                CL_Target *target) :
	CL_Blit_Transparent_RLE(provider, _bytes_per_pixel)
	{
		CL_PixelData input(
		        target->get_red_mask(),
			target->get_green_mask(),
			target->get_blue_mask(),
			target->get_alpha_mask(),
			provider,
			bytes_per_pixel);
		
		CL_PixelData alpha(0,0,0,255,provider,1);
		
		for (int y=0; y<height*no_sprs; y++)
			rle_lines[y] = make_rle_line(input.get_line_pixel(y), alpha.get_line_pixel(y));
	};
	   

      
};

#endif
