/*
	$Id: display.cpp,v 1.9 1999/07/13 21:55:11 fischlustig Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include <stdlib.h>
#include <iostream.h>
#include <string.h>

#include "Common/array.h"
#include "Layer1/Display/API/display.h"


CL_Array<CL_DisplayCard> CL_Display::cards;
int CL_Display::num_cards = 0;

void CL_Display::flip_display(bool sync)
{
	CL_Display::get_current_card()->flip_display(sync);
}

void CL_Display::clear_display(float red, float green, float blue, float alpha)
{
	CL_Display::get_current_card()->clear_display(red, green, blue, alpha);
}

void CL_Display::set_palette(CL_Palette *palette)
{
	CL_Display::get_current_card()->set_palette(palette);
}

CL_Palette *CL_Display::get_palette()
{
	return CL_Display::get_current_card()->get_palette();
}

void CL_Display::set_videomode(CL_VidMode *mode)
{
	CL_Display::get_current_card()->set_videomode(mode);
}

void CL_Display::set_videomode(int width, int height, int bpp)
{
	CL_Display::get_current_card()->set_videomode(width, height, bpp);
}

int CL_Display::get_width()
{
	return CL_Display::get_current_card()->get_width();
}

int CL_Display::get_height()
{
	return CL_Display::get_current_card()->get_height();
}

int CL_Display::get_bpp()
{
	return CL_Display::get_current_card()->get_bpp();
}

void CL_Display::push_clip_rect()
{
	CL_Display::get_current_card()->push_clip_rect();
}

void CL_Display::push_clip_rect(const CL_ClipRect &rect)
{
	CL_Display::get_current_card()->push_clip_rect(rect);
}

CL_ClipRect CL_Display::get_clip_rect()
{
	return CL_Display::get_current_card()->get_clip_rect();
}

void CL_Display::set_clip_rect(const CL_ClipRect &rect)
{
	CL_Display::get_current_card()->set_clip_rect(rect);
}

void CL_Display::pop_clip_rect()
{
	CL_Display::get_current_card()->pop_clip_rect();
}

void CL_Display::fill_rect(int x1, int y1, int x2, int y2, float r, float g, float b, float a)
{
	CL_Display::get_current_card()->fill_rect(x1, y1, x2, y2, r, g, b, a);
}

void CL_Display::draw_line(int x1, int y1, int x2, int y2, float r, float g, float b, float a)
{
	CL_Display::get_current_card()->draw_line(x1, y1, x2, y2, r, g, b, a);
}

void CL_Display::sync_buffers()
{
	CL_Display::get_current_card()->sync_buffers();
}
