/*
	$Id: lockable_surface.cpp,v 1.2 1999/06/24 04:23:26 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include "../API/display.h"
#include "../API/lockable_surface.h"
#include "displaycard_generic.h"
#include "System/API/cl_assert.h"

CL_LockableSurface *CL_LockableSurface::create(
	int width,
	int height,
	int no_sprs,
	int minimum_alpha_depth,
	CL_DisplayCard *card)
{
	CL_DisplayCard_Generic *generic = (CL_DisplayCard_Generic *) card;
	if (generic == NULL)
		generic = (CL_DisplayCard_Generic *) CL_Display::get_current_card();

	cl_assert(generic != NULL);
	return generic->create_lockable_surface(
		width,
		height,
		no_sprs,
		minimum_alpha_depth);
}
