/*
	$Id: target_ximage_dga.cpp,v 1.2 1999/04/08 00:37:50 vogel Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include "System/API/cl_assert.h"
#include "target_ximage_dga.h"

#include <iostream.h>
#include <string.h>

CL_Target_XImage_DGA::CL_Target_XImage_DGA(
	XVisualInfo visual_info,
	Display *dpy,
	unsigned int width,
	unsigned int height)
{
/*	m_visual_info = visual_info;
	m_dpy = dpy;
	m_width = width;
	m_height = height;
	
	int image_size = get_pitch()*height;
	
	m_dga_image = XDGACreateImage(
		dpy,
		visual_info.visual,
		visual_info.depth, // PTC does this: DefaultDepth(dpy,0),
		ZPixmap,
		NULL,
		&m_dgainfo,
		width,
		height);
	
	cl_assert(m_dga_image != NULL);

	// Create shared memory segment:
	m_dgainfo.dgaid = dgaget(IPC_PRIVATE, image_size, IPC_CREAT|0777);
	cl_assert(m_dgainfo.dgaid >= 0);
	
	// Get memory address to segment:
	m_dgainfo.dgaaddr = (char *) dgaat(m_dgainfo.dgaid, 0, 0);
	
	// Tell XServer that it may only read from it and attach to display:
	m_dgainfo.readOnly = True;
	XDGAAttach (dpy, &m_dgainfo);

	// Fill the XImage struct:
	m_dga_image->data = m_dgainfo.dgaaddr;*/
}
		
CL_Target_XImage_DGA::~CL_Target_XImage_DGA()
{
/*	XDestroyImage(m_dga_image);

	// Detach dga image from display:
	XDGADetach (m_dpy, &m_dgainfo);
	
	// Clean up shared memory:
	dgadt(m_dgainfo.dgaaddr);
	dgactl(m_dgainfo.dgaid, IPC_RMID, 0);*/
}

void CL_Target_XImage_DGA::put_image(Drawable win, GC gc)
{
/*	XDGAPutImage(
		m_dpy,
		win,
		gc,
		m_dga_image,
		0, 0,
		0, 0,
		m_width,
		m_height,
		False);*/
}

bool CL_Target_XImage_DGA::lock()
{
	return true;
}
	
void CL_Target_XImage_DGA::unlock()
{
}

void *CL_Target_XImage_DGA::get_data()
{
	return m_dga_image->data;
}

unsigned int CL_Target_XImage_DGA::get_width()
{
	return m_width;
}

unsigned int CL_Target_XImage_DGA::get_height()
{
	return m_height;
}

unsigned int CL_Target_XImage_DGA::get_pitch()
{
	int bytes_per_pixel = (get_depth()+7)/8;

	return m_width*bytes_per_pixel;
}
	
unsigned int CL_Target_XImage_DGA::get_depth()
{
	int hack = (m_visual_info.depth+15)/16;
	return hack*16;

//	return m_visual_info.depth;

//	return BitmapUnit(m_dpy); // <-- always returns 32 bpp!!!
}

unsigned int CL_Target_XImage_DGA::get_red_mask()
{
	return m_visual_info.red_mask;
}

unsigned int CL_Target_XImage_DGA::get_green_mask()
{
	return m_visual_info.green_mask;
}

unsigned int CL_Target_XImage_DGA::get_blue_mask()
{
	return m_visual_info.blue_mask;
}

unsigned int CL_Target_XImage_DGA::get_alpha_mask()
{
//	return m_visual_info.alpha_mask; // no alpha mask in visualinfo struct!?
	return 0;
}

CL_Palette *CL_Target_XImage_DGA::get_palette()
{
	return NULL;
}
