/*
	$Id: target_ximage_dga.h,v 1.2 1999/04/08 00:37:50 vogel Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_target_ximage_dga
#define header_target_ximage_dga

#ifdef USE_X11

#include "target_ximage.h"

// #include <X11/extensions/XDGA.h>

class CL_Target_XImage_DGA : public CL_Target_XImage
{
public:
	CL_Target_XImage_DGA(
		XVisualInfo visual_info,
		Display *dpy,
		unsigned int width,
		unsigned int height);
		
	virtual ~CL_Target_XImage_DGA();

	virtual bool lock();
	virtual void unlock();

	virtual void *get_data();

	virtual unsigned int get_width();
	virtual unsigned int get_height();
	virtual unsigned int get_pitch();
	
	virtual unsigned int get_depth();
	virtual unsigned int get_red_mask();
	virtual unsigned int get_green_mask();
	virtual unsigned int get_blue_mask();
	virtual unsigned int get_alpha_mask();

	virtual CL_Palette *get_palette();
	
	void put_image(Drawable win, GC gc);
	
protected:
	XVisualInfo m_visual_info;
	Display *m_dpy;
	
	unsigned int m_width;
	unsigned int m_height;

	XImage *m_dga_image;
};

#endif /*USE_X11*/

#endif
