/*
	$Id: target_ximage_std.h,v 1.3 1999/06/04 02:58:39 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_target_ximage_std
#define header_target_ximage_std

#ifdef USE_X11

#include "target_ximage.h"

class CL_Target_XImage_Std : public CL_Target_XImage
{
public:
	CL_Target_XImage_Std(
		XVisualInfo visual_info,
		Display *dpy,
		unsigned int width,
		unsigned int height);

	CL_Target_XImage_Std(
		XVisualInfo visual_info,
		Display *dpy,
		unsigned int width,
		unsigned int height,
		XImage *image,
		bool delete_ximage);
		
	virtual ~CL_Target_XImage_Std();

	virtual bool lock();
	virtual void unlock();

	virtual void *get_data();

	virtual unsigned int get_width();
	virtual unsigned int get_height();
	virtual unsigned int get_pitch();
	
	virtual unsigned int get_depth();
	virtual unsigned int get_red_mask();
	virtual unsigned int get_green_mask();
	virtual unsigned int get_blue_mask();
	virtual unsigned int get_alpha_mask();

	virtual CL_Palette *get_palette();
	
	virtual void put_image(Drawable win, GC gc);
	
protected:
	XVisualInfo m_visual_info;
	Display *m_dpy;
	
	unsigned int m_width;
	unsigned int m_height;

	XImage *m_std_image;
	
	bool m_delete_ximage;
};

#endif /*USE_X11*/

#endif
