/*
	$Id: keyboard.h,v 1.5 1999/04/24 17:09:28 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l1_component="Input"

#ifndef header_keyboard
#define header_keyboard

#include "inputdevice.h"

class CL_Keyboard : public CL_InputDevice
//: Keyboard interface in ClanLib.
// This is the keyboard input device interface. It contains all the extra
// functions needed by the keyboard, which didn't fit into the general
// CL_InputDevice abstraction.
{
public:
	virtual ~CL_Keyboard() { return; }

	static bool get_keycode(int button_no);
	//: Returns true if the specified button is down on the keyboard.
	//: <br>
	//: This static function is an easier way of writing 
	//: CL_Input::keyboards[0]->get_button->is_pressed();
	//!param: button_no - Button number checked for being pressed.
	//!retval: True if the key is pressed.

	enum
	{
		KEY_A, KEY_B, KEY_C, KEY_D, KEY_E, KEY_F, KEY_G, KEY_H, KEY_I, KEY_J,
		KEY_K, KEY_L, KEY_M, KEY_N, KEY_O, KEY_P, KEY_Q, KEY_R, KEY_S, KEY_T,
		KEY_U, KEY_V, KEY_W, KEY_X, KEY_Y, KEY_Z,
		KEY_0, KEY_1, KEY_2, KEY_3, KEY_4, KEY_5, KEY_6, KEY_7, KEY_8, KEY_9,
		KEY_F1, KEY_F2, KEY_F3, KEY_F4, KEY_F5, KEY_F6, KEY_F7, KEY_F8, KEY_F9,
		KEY_F10, KEY_F11, KEY_F12,
		KEY_ESCAPE,
		KEY_LEFT, KEY_RIGHT, KEY_UP, KEY_DOWN,
		KEY_LCTRL, KEY_RCTRL,
		KEY_LSHIFT, KEY_RSHIFT,
		KEY_ALT, KEY_ALTGR,
		KEY_TAB, KEY_ENTER, KEY_SPACE, KEY_BACKSPACE,
		KEY_INSERT, KEY_DELETE, KEY_HOME, KEY_END, KEY_PAGEUP, KEY_PAGEDOWN,
		KEY_CAPSLOCK, KEY_NUMLOCK, KEY_SCRLOCK, KEY_PRINT, KEY_PAUSE,
		KEY_KP_DIV, KEY_KP_MULT, KEY_KP_MINUS, KEY_KP_PLUS, KEY_KP_ENTER,

		KEY_NONE_OF_THE_ABOVE,
		NUM_KEYS
	};
	//: Key buttons available on a keyboard.
};

#endif
