/*
	$Id: input.cpp,v 1.5 1999/08/15 11:30:08 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include "Layer1/Input/API/input.h"
#include "Layer1/Input/API/keyboard.h"
#include "Layer1/Input/API/mouse.h"

CL_Array<CL_Keyboard> CL_Input::keyboards;
CL_Array<CL_InputDevice> CL_Input::joysticks;
CL_Array<CL_InputDevice> CL_Input::pointers;

bool CL_Keyboard::get_keycode(int button_no)
{
	return CL_Input::keyboards[0]->get_button(button_no)->is_pressed();
}
/*
bool CL_Keyboard::check_modifier(int button_no)
{
	return CL_Input::keyboards[0]->get_button(button_no)->is_pressed();
}
*/
/*
	MBN: obsolete

int CL_Keyboard::map_to_ascii(int button_num)
{
	int key = -1;
	switch (button_num)
	{
	case KEY_A: key = 'A'; break;
	case KEY_B: key = 'B'; break;
	case KEY_C: key = 'C'; break;
	case KEY_D: key = 'D'; break;
	case KEY_E: key = 'E'; break;
	case KEY_F: key = 'F'; break;
	case KEY_G: key = 'G'; break;
	case KEY_H: key = 'H'; break;
	case KEY_I: key = 'I'; break;
	case KEY_J: key = 'J'; break;
	case KEY_K: key = 'K'; break;
	case KEY_L: key = 'L'; break;
	case KEY_M: key = 'M'; break;
	case KEY_N: key = 'N'; break;
	case KEY_O: key = 'O'; break;
	case KEY_P: key = 'P'; break;
	case KEY_Q: key = 'Q'; break;
	case KEY_R: key = 'R'; break;
	case KEY_S: key = 'S'; break;
	case KEY_T: key = 'T'; break;
	case KEY_U: key = 'U'; break;
	case KEY_V: key = 'V'; break;
	case KEY_W: key = 'W'; break;
	case KEY_X: key = 'X'; break;
	case KEY_Y: key = 'Y'; break;
	case KEY_Z: key = 'Z'; break;
	case KEY_0: key = '0'; break;
	case KEY_1: key = '1'; break;
	case KEY_2: key = '2'; break;
	case KEY_3: key = '3'; break;
	case KEY_4: key = '4'; break;
	case KEY_5: key = '5'; break;
	case KEY_6: key = '6'; break;
	case KEY_7: key = '7'; break;
	case KEY_8: key = '8'; break;
	case KEY_9: key = '9'; break;
	case KEY_SPACE: key = ' '; break;
	case KEY_ENTER: key = 13; break;
	case KEY_KP_ENTER: key = 13; break;
	}

	return key;
}
*/

int CL_Mouse::get_x()
{
	return (int) CL_Input::pointers[0]->get_cursor(0)->get_x();
}

int CL_Mouse::get_y()
{
	return (int) CL_Input::pointers[0]->get_cursor(0)->get_y();
}

bool CL_Mouse::left_pressed()
{
	return CL_Input::pointers[0]->get_button(0)->is_pressed();
}

bool CL_Mouse::middle_pressed()
{
	return CL_Input::pointers[0]->get_button(1)->is_pressed();
}

bool CL_Mouse::right_pressed()
{
	return CL_Input::pointers[0]->get_button(2)->is_pressed();
}
