/*
	$Id: keyboard_svgalib.h,v 1.2 1998/12/24 23:34:57 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_keyboard_svgalib
#define header_keyboard_svgalib

#ifdef USE_SVGALIB

#include "../API/input.h"
#include "../API/inputbutton.h"
#include "../API/inputbuffer.h"
#include "../API/keyboard.h"

class CL_InputButton_SVGAKeyboard : public CL_InputButton
{
protected:
	int key;

public:
	CL_InputButton_SVGAKeyboard(int _key);
	virtual bool is_pressed();
};

class CL_InputBuffer_SVGAKeyboard : public CL_InputBuffer
{
public:
	virtual int peek_key();
	virtual int get_key();
	virtual int keys_left();
	virtual void clear();
};

class CL_SVGAKeyboard : public CL_Keyboard
{
protected:
	CL_Array<CL_InputButton_SVGAKeyboard> buttons;
	CL_InputBuffer_SVGAKeyboard buffer;

public:
	CL_SVGAKeyboard();
	virtual ~CL_SVGAKeyboard();

	// CL_Input and CL_Keyboard:
	virtual char *get_name();

	virtual int get_num_buttons();
	virtual CL_InputButton *get_button(int button_num);

	virtual int get_num_axes();
	virtual CL_InputAxis *get_axis(int axis_num);

	virtual int get_num_hats();
	virtual CL_InputHat *get_hat(int hat_num);

	virtual int get_num_buffers();
	virtual CL_InputBuffer *get_buffer(int buffer_num);

	virtual int get_num_cursors();
	virtual CL_InputCursor *get_cursor(int cursor_num);
};

#endif

#endif
