
#ifdef USE_NETWORK

#ifndef header_network_generic
#define header_network_generic

#include <stdio.h>
#include "../API/network.h"
#include "../API/netcomputer.h"
#include "../API/netgroup.h"
#include "../API/netgame.h"
#include "../API/netmessage.h"
#include "Layer1/System/API/thread.h"
#include "Layer1/System/API/mutex.h"
#include "Layer1/System/API/cl_assert.h"
#include "Layer1/System/API/error.h"
#include "Layer1/IOData/Generic/inputsource_memory_generic.h"
#include "Layer1/IOData/Generic/outputsource_memory_generic.h"
#include "Common/queue.h"

#include "network_delivery_impl.h"

class CL_NetGame_Generic;
class CL_IncomingGame;

class CL_Network_Generic : public CL_Network
{
public:
	CL_Network_Generic(CL_ConnectionProvider *provider);
	~CL_Network_Generic();

	void find_games_broadcast(
		CL_String game_id,
		int port);
	void find_game_at(
		CL_String game_id,
		const char *host_address,
		int port);
	bool peek_game_found();
	CL_NetGame *receive_game_found(int timeout_millis);
	void clear_games_found();
	CL_NetGame *create_game(CL_String game_id, int port);

	CL_ConnectionProvider *provider;
	CL_Queue<CL_NetGame*> queue;
	CL_List<CL_NetGame_Generic> netgames;
	CL_List<CL_IncomingGame> incoming_netgames;

	static CL_Network_Generic *self;
	
	void keep_alive();
};

class CL_IncomingGame
{
public:
	CL_Connection *connection;
	CL_String game_id;
};

#endif

#endif
