#ifndef header_network_delivery_win32
#define header_network_delivery_win32

#include "Common/link.h"
#include "Layer1/Network/Generic/network_delivery_impl.h"

class CL_Win32PipeConnection;
class CL_Win32AcceptSocket;
class CL_UDPConnection_Win32;
class CL_Win32Socket;
class CL_Connections_Win32 : public CL_ConnectionProvider
{
protected:
	CL_List<CL_Win32Socket> connections;
	CL_List<CL_UDPConnection_Win32> udp_connections;
	CL_List<CL_Win32AcceptSocket> accepting_connections;

public:
	CL_Connections_Win32();
	virtual ~CL_Connections_Win32();

	virtual CL_Connection *get_client() { return NULL; }
	virtual CL_UDPConnection *create_udp_connection(unsigned int port);
	virtual CL_Connection *create_tcp_connection(
		int ip_addr,
		int port);
	virtual CL_Connection *accept();
	virtual void start_accept_on_port(int port);
	virtual void stop_accept_on_port(int port);
	virtual void wait_for_connection_data(CL_Mutex *mutex);
	virtual void remove_connection(CL_Connection *removed_connection);
};

#endif