/*
	$Id: network_win32.cpp,v 1.12 1999/08/24 17:27:16 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	$Log: network_win32.cpp,v $
	Revision 1.12  1999/08/24 17:27:16  starch
	Modified network impl under windows.
	
	Revision 1.10  1999/08/10 22:16:40  mbn
	Made the win32 makefiles/project files actually compile. Check out this new concept!
	
	Revision 1.9  1999/06/21 00:40:24  mbn
	Moved _all_ API functions into generic.
	
	Revision 1.8  1999/05/27 21:44:26  starch
	Added const to api classes.
	
	Revision 1.7  1999/04/10 21:18:55  starch
	Fixed some network bugs.
	
	Revision 1.6  1999/01/03 06:26:40  starch
	We would really really like to tell what we have done with this code - but then
	again, we would have to shoot you! :-)
	Anyways, we made the network code WORK! Now that's a new cool concept!
	
	Revision 1.3  1998/12/25 01:36:13  starch
	Made lots of changes. Fixed a gazillion include errors, rewrote the win32 part,
	plus various hacks.


	------------------------------------------------------------------------
*/

#ifdef USE_NETWORK

#include <iostream.h>

#include <windows.h>
#include <process.h>
#include "Layer1/Network/API/network.h"
#include "Layer1/System/API/cl_assert.h"
#include "Layer1/Network/Generic/network_generic.h"
//#include "Layer1/Network/Generic/TransportLayer/network_delivery_packets.h"
#include "network_delivery_win32.h"
#include "network_delivery_winsocket.h"
#include "network_win32.h"

CL_Network_Generic *CL_Network_DX::network = NULL;

CL_Network_DX::CL_Network_DX()
{
	WORD winsock_version = MAKEWORD( 2, 0 ); 
	WSADATA wsaData;
	int err = WSAStartup(winsock_version, &wsaData);
	cl_assert(err == 0);

	char name[100];
	gethostname(name, 100);

	HOSTENT *ent = gethostbyname(name);

	unsigned long local_ip = *((unsigned long *) *ent->h_addr_list);

	network = new CL_Network_Generic(new CL_Connections_Win32);
}

CL_Network_DX::~CL_Network_DX()
{
	delete network;
	network = NULL;
}

#endif // USE_NETWORK