/*
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.
*/

#ifndef header_clansound
#define header_clansound

enum CS_FORMAT
{
	CS_8BIT_MONO,
	CS_8BIT_STEREO,
	CS_16BIT_MONO,
	CS_16BIT_STEREO
};

int cs_init();
void cs_deinit();

int cs_create_sample(int format, void *data, int data_size);
void cs_release_sample(int sample_id);

int cs_create_session(int sample_id);
int cs_create_session_streamed(int format);
void cs_play(int session_id);
void cs_stop(int session_id);
void cs_flush(int session_id);
void cs_set_volume(int session_id, int volume);
void cs_set_pan(int session_id, int pan); // -100 to 100
void cs_set_frequency(int session_id, int frequency);
void cs_set_position(int session_id, int position); // number of sample to seek
bool cs_is_playing(int session_id);
int cs_release_session(int session_id);
int cs_update_stream(int session_id, void *data, int data_size);
int cs_ask_update_stream(int session_id);
void cs_eof_stream(int session_id);

#endif
