/*
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.
*/

#ifdef USE_CLANSOUND

#include <string.h>
#include <iostream.h>
#include "mixer.h"

#ifdef USE_I386
extern "C"
{
	void mixer_clip_asm(
		int *mix_buffer2,
		short *mix_buffer,
		int size);
}
#endif

short *mix_buffer;
int *mix_buffer2;
int mix_buffer_size;

void cs_mixer_init()
{
	mix_buffer_size = cs_oss_get_frag_size()*2;
	mix_buffer = new short[mix_buffer_size];
	mix_buffer2 = new int[mix_buffer_size];
}

void cs_mixer_deinit()
{
	delete[] mix_buffer;
	delete[] mix_buffer2;
}

void cs_mixer_mix()
{
	int num_sessions = sessions.get_num_items();
	
	memset(mix_buffer2, 0, sizeof(int)*mix_buffer_size);

	for (int i=0; i<num_sessions; i++)
	{
		if (sessions[i] == NULL) continue;
		if (sessions[i]->is_playing() == false) continue;

		sessions[i]->mix_to(mix_buffer2, mix_buffer_size >> 1);
	}

#ifdef USE_I386
	mixer_clip_asm(mix_buffer2, mix_buffer, mix_buffer_size);
#else
	for (int k=0; k<mix_buffer_size; k++)
	{
		mix_buffer2[k] >>= 1;
	
		if      (mix_buffer2[k] > 32200)  mix_buffer[k] = 32200;
		else if (mix_buffer2[k] < -32200) mix_buffer[k] = -32200;
		else                              mix_buffer[k] = mix_buffer2[k];
	}
#endif

	cs_oss_write_fragment(mix_buffer);
}

#endif
