/*
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.

	OSS Documentation can be found at http://www.opensound.com
*/

#ifndef header_oss
#define header_oss

#include "soundserver.h"

int cs_oss_init();
//: Initialize sound playback.
//!retval: Non-zero if soundcard successfully initialized.

void cs_oss_deinit();
//: Deinitializes sound playback.

void cs_oss_silence();
//: Called when we have no samples to play - and wants to tell the soundcard
//: about this possible event.

bool cs_oss_is_full();
//: Returns true if all fragments are filled with data.

int cs_oss_get_frag_size();
//: Returns the buffer size used by device (returned as num [stereo] samples).

int cs_oss_get_fd();
//: Returns file descriptor used by device.

void cs_oss_write_fragment(short *data);
//: Writes a fragment to the soundcard.

#endif
