/*
	ClanSound, sound mixing library written for ClanLib.
	Copyright (c)1998 Magnus Norddahl / ClanSoft.
*/

#ifdef USE_CLANSOUND

#include <iostream.h>

#include "soundserver.h"
#include "sample.h"

CS_Sample::CS_Sample(int format, void *input, int size)
{
	switch (format)
	{
	case CS_8BIT_MONO:
		{
			char *input_c = (char *) input;
			num_samples = size;
			data = new short[num_samples*2];
			for (int i=0; i<num_samples; i++)
			{
				data[i*2+0] = (((int) input_c[i])/*-128*/)*256;
				data[i*2+1] = (((int) input_c[i])/*-128*/)*256;
			}
		}
		break;

	case CS_8BIT_STEREO:
		{
			char *input_c = (char *) input;
			num_samples = size/2;
			data = new short[num_samples*2];
			for (int i=0; i<num_samples; i++)
			{
				data[i*2+0] = ((int) input_c[i*2])*256;
				data[i*2+1] = ((int) input_c[i*2+1])*256;
			}
		}
		break;

	case CS_16BIT_MONO:
		{
			short *input_s = (short *) input;
			num_samples = size/2;
			data = new short[num_samples*2];
			for (int i=0; i<num_samples; i++)
			{
				data[i*2+0] = input_s[i];
				data[i*2+1] = input_s[i];
			}
		}
		break;

	case CS_16BIT_STEREO:
		{
			num_samples = size/4;
			data = new short[num_samples*2];
			memcpy(data, input, size);
		}
		break;

	default:
		cout << "ClanSound: Unknown sample format!" << endl;
		exit(1);
	}
}

CS_Sample::~CS_Sample()
{
	delete[] data;
}

#endif
