/*
	$Id: cardplayback_clan.h,v 1.4 1999/08/23 18:40:07 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_cardplayback_clan
#define header_cardplayback_clan

#ifdef USE_CLANSOUND

#include "../Generic/cardsession_manager.h"
#include "soundcard_clan.h"

class CL_CardPlayback_ClanSound : public CL_CardSoundBuffer_Playback
{
protected:
	int session_id;
	
	float volume;
	float pan;
	int frequency;

public:
	CL_CardPlayback_ClanSound(int sample_id);
	virtual ~CL_CardPlayback_ClanSound();

	// Functions inherited from Generic:
	// ---------------------------------
	virtual int get_position();
	virtual float get_position_relative();

	virtual bool set_position(int new_pos);
	virtual bool set_position_relative(float new_pos);

	virtual int get_length(); // -1 if unknown

	virtual int get_frequency();
	virtual bool set_frequency(int new_freq);

	virtual float get_volume();
	virtual bool set_volume(float new_volume);

	virtual float get_pan();
	virtual bool set_pan(float new_pan);

	virtual void set_looping(bool looping);
	virtual bool get_looping();

	virtual void play();
	virtual void stop();

	virtual bool is_playing();
};

#endif /* USE_CLANSOUND */

#endif
