/*
	$Id: soundbuffer_static_clan.cpp,v 1.3 1999/08/23 20:44:47 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Sound card impl. that uses the ClanSound library.

*/

#ifdef USE_CLANSOUND

#include "Layer1/Sound/Generic/cardsoundbuffer_static.h"
#include "soundbuffer_static_clan.h"
#include "Layer1/System/API/cl_assert.h"
#include "cardplayback_clan.h"

CL_CardBuffer_Static_ClanSound::CL_CardBuffer_Static_ClanSound(
	CL_StaticSoundProvider *provider)
: CL_CardSoundBuffer_Static(provider)
{
	int format;

	switch (provider->get_format())
	{
	case sf_8bit_signed:
		format = CS_8BIT_MONO;
		break;
		
	case sf_8bit_signed_stereo:
		format = CS_8BIT_STEREO;
		break;
		
	case sf_16bit_signed:
		format = CS_16BIT_MONO;
		break;
		
	case sf_16bit_signed_stereo:
		format = CS_16BIT_STEREO;
		break;
		
	default:
		format = -1;
		cl_assert(false);
	}

	sample_id = cs_create_sample(
		format,
		provider->get_data(),
		provider->data_size());
}

CL_CardBuffer_Static_ClanSound::~CL_CardBuffer_Static_ClanSound()
{
	cs_release_sample(sample_id);
}

CL_CardSoundBuffer_Playback *CL_CardBuffer_Static_ClanSound::prepare()
{
	return new CL_CardPlayback_ClanSound(sample_id);
}

#endif
