/*
	$Id: soundbuffer_stream_clan.h,v 1.3 1999/05/30 21:48:00 fischlustig Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Sound card impl. that uses the ClanSound library.

*/

#ifndef header_soundbuffer_stream_clan
#define header_soundbuffer_stream_clan

#ifdef USE_CLANSOUND

#include "Layer1/Sound/API/stream_soundprovider.h"
#include "soundcard_clan.h"
#include "cardplayback_clan.h"
#include "Layer1/System/Unix/init_linux.h"

class CL_CardPlayback_ClanSound_Stream
: public CL_CardPlayback_ClanSound, CL_System_KeepAlive
{
protected:
	CL_StreamSoundProvider *provider;
	CL_StreamSoundProvider_Session *provider_session;

public:
	CL_CardPlayback_ClanSound_Stream(CL_StreamSoundProvider *provider);
	virtual ~CL_CardPlayback_ClanSound_Stream();

	virtual bool set_position(int new_pos);
	virtual void play();
	virtual void stop();
	
	virtual bool keep_alive();
};

#endif /* USE_CLANSOUND */

#endif
