/*
	$Id: soundcard_clan.cpp,v 1.4 1999/08/23 20:44:47 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifdef USE_CLANSOUND

#include "soundcard_clan.h"
#include "soundbuffer_static_clan.h"
#include "soundbuffer_stream_clan.h"
#include "Layer1/System/API/cl_assert.h"
#include "Layer1/Sound/Generic/soundbuffer_stream.h"

CL_SoundCard_ClanSound::CL_SoundCard_ClanSound()
{
	cs_init();

	name = "ClanSound card";
	card_no = 0;
}

CL_SoundCard_ClanSound::~CL_SoundCard_ClanSound()
{
	cs_deinit();
}

// Functions inherited from API:
// -----------------------------

CL_StreamSoundProvider *CL_SoundCard_ClanSound::get_microphone()
{
	return NULL;
}

CL_StreamSoundProvider *CL_SoundCard_ClanSound::get_line_in()
{
	return NULL;
}

void CL_SoundCard_ClanSound::stop_all()
{
	// we need a generic strategy for this
}

void CL_SoundCard_ClanSound::set_global_volume(int /*volume*/)
{
	// and this one...
}

void CL_SoundCard_ClanSound::set_global_pan(int /*pan*/)
{
	// and this...
}

// Functions inherited from Generic:
// ---------------------------------

CL_CardSoundBuffer_Static *CL_SoundCard_ClanSound::create_soundbuffer_static(
		CL_StaticSoundProvider *provider)
{
	return new CL_CardBuffer_Static_ClanSound(provider);
}

CL_CardSoundBuffer_Playback *CL_SoundCard_ClanSound::create_cardsoundbuffer_playback_streamed(
		CL_SoundBuffer_Generic_Stream *provider)
{
	return new CL_CardPlayback_ClanSound_Stream(
		provider->get_stream_provider());
}

#endif
