/*
	$Id: soundcard_clan.h,v 1.4 1999/08/23 20:44:47 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_soundcard_clan
#define header_soundcard_clan

#ifdef USE_CLANSOUND

#include "ClanSound/clansound.h"
#include "Layer1/Sound/Generic/soundcard_generic.h"

class CL_SoundCard_ClanSound : public CL_SoundCard_Generic
{
public:
	CL_SoundCard_ClanSound();
	virtual ~CL_SoundCard_ClanSound();

	// Member vars from CL_SoundCard:
//	CL_String name;
//	int card_no;

	// Functions inherited from API:
	// -----------------------------
	virtual CL_StreamSoundProvider *get_microphone();
	virtual CL_StreamSoundProvider *get_line_in();

	virtual void stop_all();
	virtual void set_global_volume(int volume);
	virtual void set_global_pan(int pan);

	// Functions inherited from Generic:
	// ---------------------------------
	virtual CL_CardSoundBuffer_Static *create_soundbuffer_static(
		CL_StaticSoundProvider *provider);
		
	virtual CL_CardSoundBuffer_Playback *create_cardsoundbuffer_playback_streamed(
		CL_SoundBuffer_Generic_Stream *provider);
};

#endif /* USE_CLANSOUND */

#endif
