#include <windows.h>
#include <dsound.h>

#include "sound_dx.h"
#include "soundcard_dx.h"
#include "Layer1/System/Win32/app_windows.h"

CL_SoundCard *CL_Sound_DX::cur_card = NULL;

BOOL WINAPI EnumerateSoundDevices(LPGUID lpGuid, LPCSTR lpstrDescription, LPCSTR lpstrModule, LPVOID lpContext);

CL_Sound_DX::CL_Sound_DX()
{
	CL_List<SSoundCardInfo> soundinfo;
	BOOL result = DirectSoundEnumerate(EnumerateSoundDevices, &soundinfo);

	CL_Sound::num_cards = soundinfo.get_num_items()+1;
	cout << "ClanLib: Number of sound cards: " << CL_Sound::num_cards << endl;

	int card_no=0;

	CL_Sound::cards.add(new CL_SoundCard_DX(card_no++, CL_String("Default device"), NULL), 0);

	for (int i=1;i<soundinfo.get_num_items()+1;i++)
	{
		CL_Sound::cards.add(new CL_SoundCard_DX(card_no++, soundinfo[i-1]->name, &soundinfo[i-1]->guid), i);
	}

	CL_Iterator<SSoundCardInfo> counter(soundinfo);
	while (counter.next() != NULL)
	{
		SSoundCardInfo *del_item = counter();
		counter.remove();
		delete del_item;
	}

	CL_Sound_DX::cur_card = CL_Sound::cards[0];
	CL_Sound::preload_cards.add(CL_Sound_DX::cur_card);
}

CL_Sound_DX::~CL_Sound_DX()
{
	for (int i=0;i<CL_Sound::cards.get_num_items();i++)
	{
		delete CL_Sound::cards[i];
	}
}

BOOL WINAPI EnumerateSoundDevices(
	LPGUID lpGuid,						
	LPCSTR lpstrDescription,	
	LPCSTR lpstrModule,				
	LPVOID lpContext)
{
	if (lpGuid!=NULL)
	{
		cout << lpstrDescription << ", " << lpstrModule << endl;
		SSoundCardInfo *info = new SSoundCardInfo;
		memcpy(&info->guid, lpGuid, sizeof(GUID));
		info->name = CL_String(lpstrDescription);
		((CL_List<SSoundCardInfo> *) lpContext)->add(info);
	}
	return TRUE;
}

CL_StreamSoundProvider *CL_Sound::get_microphone()
{
	if (CL_Sound_DX::cur_card != NULL) return CL_Sound_DX::cur_card->get_microphone();
	return NULL;
}

CL_StreamSoundProvider *CL_Sound::get_line_in()
{
	if (CL_Sound_DX::cur_card != NULL) return CL_Sound_DX::cur_card->get_line_in();
	return NULL;
}

void CL_Sound::select_card(CL_SoundCard *card)
{
	CL_Sound_DX::cur_card = card;
}

void CL_Sound::select_card(int card_no)
{
	CL_Sound_DX::cur_card = CL_Sound::cards[card_no];
}

CL_SoundCard *CL_Sound::get_current_card()
{
	return CL_Sound_DX::cur_card;
}
