#ifndef header_soundbuffer_playback_dx
#define header_soundbuffer_playback_dx

#include "Layer1/Sound/Generic/cardsoundbuffer_playback.h"
#include "Layer1/System/API/timer_manager.h"
#include "Common/link.h"

class CL_CardSoundBufferStatic_DX;
class CL_CardSoundBuffer_Playback_DX : public CL_CardSoundBuffer_Playback
{
	LPDIRECTSOUNDBUFFER buffer;
	CL_CardSoundBufferStatic_DX *parent_buffer;
	
	void check_for_lost();
public:
	CL_CardSoundBuffer_Playback_DX(CL_CardSoundBufferStatic_DX *parent_buffer);
	virtual ~CL_CardSoundBuffer_Playback_DX();

	virtual int get_position();
	virtual float get_position_relative();

	virtual bool set_position(int new_pos);
	virtual bool set_position_relative(float new_pos);

	virtual int get_length(); // -1 if unknown

	virtual int get_frequency();
	virtual bool set_frequency(int new_freq);

	virtual float get_volume();
	virtual bool set_volume(float new_volume);

	virtual float get_pan();
	virtual bool set_pan(float new_pan);

	virtual void play();
	virtual void stop();

	virtual bool is_playing();
	virtual void set_looping(bool loop);
};

#endif
