#include <stdlib.h>
#include <dsound.h>
#include "Layer1/System/Win32/app_windows.h"

#include "soundbuffer_static_dx.h"
#include "soundbuffer_stream_dx.h"
#include "soundcard_dx.h"

/**************************************************************************
										CL_SoundCard_DX implementation
**************************************************************************/

CL_SoundCard_DX::CL_SoundCard_DX(int _card_no, CL_String _name, LPGUID _guid)
{
	card_no = _card_no;
	name = _name;
	is_initialized = false;
	guid = _guid;
	soundcard_enabled = false;
	soundcard = NULL;
}

CL_SoundCard_DX::~CL_SoundCard_DX()
{
	if (soundcard != NULL)
	{
		soundcard->Release();
	}
}

void CL_SoundCard_DX::init_directsound()
{
	HRESULT err;
	err = DirectSoundCreate(guid, &soundcard, NULL);
	if (err != DS_OK) { cout << "Failed to create " << name << endl; soundcard = NULL; }
	else
	{
		err = soundcard->SetCooperativeLevel(CL_WindowsSystem::hWnd, DSSCL_NORMAL);
		if (err != DS_OK) 
		{
			cout << "Failed to create " << name << endl;
			soundcard->Release();
			soundcard = NULL;
		}
		else soundcard_enabled = true;
	}

	is_initialized = true;
}

CL_CardSoundBuffer_Static *CL_SoundCard_DX::create_soundbuffer_static(CL_StaticSoundProvider *provider)
{
 	if (!is_initialized) init_directsound();

	return new CL_CardSoundBufferStatic_DX(this, provider);
}

CL_CardSoundBuffer_Playback *CL_SoundCard_DX::create_cardsoundbuffer_playback_streamed(
	CL_SoundBuffer_Generic_Stream *soundbuffer)
{
	if (!is_initialized) init_directsound();

	return new CL_CardSoundBufferPlaybackStream_DX(this, soundbuffer);
}
