/*
	$Id: cardsession_manager.h,v 1.2 1998/12/22 00:59:03 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_cardsession_manager
#define header_cardsession_manager

#include "Common/array.h"
#include "Layer1/System/API/cl_assert.h"
#include "cardsoundbuffer_playback.h"

class CL_CardSessionManager
{
	struct SPlayBackStruct
	{
		CL_CardSoundBuffer_Playback *playback;
		int reference_count;

		SPlayBackStruct(CL_CardSoundBuffer_Playback *_playback);
		virtual ~SPlayBackStruct();
	};

	CL_Array<SPlayBackStruct> playbacks;
	void garbage_collect();

public:
	CL_CardSessionManager();
	virtual ~CL_CardSessionManager();

	int add_playback(CL_CardSoundBuffer_Playback *playback_buffer);
	void add_reference(int handle);
	void remove_reference(int handle);

	CL_CardSoundBuffer_Playback *get_playback(int handle)
	{
		cl_assert(playbacks[handle] != NULL);
		cl_assert(playbacks[handle]->playback != NULL);
		return playbacks[handle]->playback;
	}
};

#endif
