/*
	$Id: settings.h,v 1.2 1999/08/25 11:18:43 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l1_component = "System"

#ifndef header_settings
#define header_settings

class CL_Settings
//: ClanLib settings.
// The class holding ClanLib state information like width/height of the current
// display.
{
public:
	static int width();
	//!retval: The width of display.
	static void width(int width);
	//: Set the width of the display.
	//!param: width - Width of the display.

	static int height();
	//!retval: The height of the display.
	static void height(int height);
	//: Set the height of the display.
	//!param: height - Height of the display.

	static int bpp();
	//!retval: Display depth represented in bits-per-pixel.
	static void bpp(int bpp);
	//: Set the display depth.
	//!param: bpp - Display depth represented in bits-per-pixel.
		 
	static int gl_buffers();
	//!retval: OpenGL buffers in use.
	static void gl_buffers(int _gl_buffers);
	//: Set which buffers OpenGL implementation should use.
	//!param: OpenGL buffers to use.

	static bool update_mouse();
	//!retval: true if mouse should be updated even if it is outside the current window.
	static void update_mouse(bool update_mouse);
	//: Set mouse mode between updating outside current window or not.
	//!param: update_mouse - true indicates that mouse should be updated even if it is outside the current window.

	static bool debug_info();
	//!retval: true if debug info is ON, false otherwise.
	static void debug_info(bool debug);
	//: Select if debug information should be shown or not (to the console).
	//!param: debug - true if debug-info should be shown, false otherwise.
};

#endif