/*
	$Id: cl_assert.cpp,v 1.4 1999/08/10 22:16:40 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include <stdlib.h>
#include <iostream.h>

#ifndef WIN32
#include <assert.h>
#else
#include <windows.h>
#endif

#include "Layer1/System/API/cl_assert.h"

CL_List<CL_AssertListener> CL_Assert::listeners;

void CL_Assert::enable_channels(int /*channel_mask*/)
{
	// not implemented yet!
}

void CL_Assert::die(bool a, char *file, int line)
{
	if (a) return;

	cout << "ClanLib Assert: " << file << ":" << line << endl;
	
	CL_Iterator<CL_AssertListener> counter(listeners);
	while (counter.next() != NULL)
		counter()->assert_occoured(file, line);
	
#ifndef WIN32
	assert(a); // make sure the thing dumps a core.
#else
//	ASSERT(a); // give me just-in-time debugging!
#endif
}

void CL_Assert::info(int channel, char *text, char *file, int line)
{
	cout << "ClanLib Info(" << channel << "): " << text << " from " << file 
		<< ":" << line << endl;
}

void CL_Assert::add_listener(CL_AssertListener *listener)
{
	listeners.add(listener);
}

void CL_Assert::remove_listener(CL_AssertListener *listener)
{
	listeners.del(listener);
}
