/*
	$Id: timer_manager.cpp,v 1.2 1998/12/22 00:59:06 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#include "Layer1/System/API/timer_manager.h"

CL_TimerCallback::CL_TimerCallback()
{
	subscribed = false;
}

CL_TimerCallback::~CL_TimerCallback()
{
	if (subscribed) unsubscribe();
}

void CL_TimerCallback::subscribe(int milliseconds, float tolerance, bool periodic, bool delete_pointer)
{
	CL_TimerManager::subscribe(milliseconds, this, tolerance, periodic, delete_pointer);
	subscribed = true;
}

void CL_TimerCallback::unsubscribe()
{
	if (subscribed)
	{
		CL_TimerManager::unsubscribe(this);
		subscribed = false;
	}
}
