/*
	$Id: implementation_clansound.cpp,v 1.4 1999/08/13 00:24:48 brn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Initialization functions for Svgalib implementation.

*/

#ifdef USE_CLANSOUND

#include "implementation_clansound.h"
#include "Layer1/Sound/ClanSound/soundcard_clan.h"
#include "implementation.h"

extern "C"
{
        DL_PREFIX char *clan_module_identify() {
	  return "Default Clansound implementation";
	}

        DL_PREFIX char* clan_module_abbreviation() {
	  return "cls";
	}

        DL_PREFIX void clan_module_init()
	{
		CL_Implementation_ClanSound::add_sound();
	}
}

char *clansound_identify() {
  return clan_module_identify();
}

char *clansound_abbreviation() {
  return clan_module_abbreviation();
}

void clansound_init() {
  clan_module_init();
}

void CL_Implementation_ClanSound::add_sound()
{
	CL_Sound::cards.add(new CL_SoundCard_ClanSound);
}

#endif
