/*
	$Id: implementation_ptc.cpp,v 1.9 1999/08/13 16:05:14 brn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Initialization functions for PTC implementation.

*/

#ifdef USE_PTC

#include <ptc/ptc.h>
#include "Layer1/Display/API/display.h"
#include "Layer1/System/Unix/implementation_ptc.h"
#include "Layer1/Display/PTC/displaycard_ptc.h"
#include "implementation_xwindow.h"
#include "Display/API/display.h"
#include "Display/X11/display_xwindow.h"
#include "Input/API/input.h"
#include "Input/X11/mouse_x11.h"
#include "Input/X11/keyboard_x11.h"
#include "Input/X11/joystick_linux.h"
#include "implementation.h"

extern "C"
{
        DL_PREFIX char* clan_module_identify() {
	  return "OpenPTC X11 target";
	}

        DL_PREFIX char* clan_module_abbreviation() {
	  return "ptc";
	}

	DL_PREFIX void clan_module_init()
	{
		CL_Implementation_PTC::add_display();
	}
}

char *ptc_identify() {
  return clan_module_identify();
}

char *ptc_abbreviation() {
  return clan_module_abbreviation();
}

void ptc_init() {
  return clan_module_init();
}

void CL_Implementation_PTC::add_display()
{
	int card_no = CL_Display::cards.get_num_items();
	CL_DisplayCard_PTC *card = new CL_DisplayCard_PTC(card_no);
	CL_Display::cards.add(card);

	CL_Input::keyboards.add(
		new CL_XWindowKeyboard(card));

	CL_Input::pointers.add(
		new CL_Mouse_XWin(card));
	
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)

	CL_LinuxJoystick *joy = new CL_LinuxJoystick();
	if (joy->init())
		CL_Input::joysticks.add(joy);
	else
		delete joy;

#endif
}

#endif



