/*
	$Id: implementation_xwindow.h,v 1.4 1999/08/13 00:24:48 brn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Initialization functions for XWindow implementation.

*/

#ifndef header_implementation_xwindow
#define header_implementation_xwindow

#ifdef USE_X11

#include "X11/Xlib.h"
#include "X11/Xutil.h"

char* xwindow_identify();
char* xwindow_abbreviation();
void xwindow_init();


class CL_Implementation_XWindow
{
public: // (was) protected:
	static bool initialized;
	static int display_counter;

	static Display *dpy;
	static Window root;
	static int default_scr;

public:
	static bool init();
	static void clean_up();

	static void add_display();
};

#endif

#endif
