/*
	$Id: app_windows.h,v 1.4 1999/03/12 03:48:53 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Header file to the Win32 initialization.

*/

#ifndef header_app_windows
#define header_app_windows

#include <windows.h>

#include "Layer1/System/API/clanapp.h"
#include "Layer1/System/API/system.h"
#include "Common/link.h"

class CL_Win32EventListener;
class CL_Win32KeepAlive;

class CL_WindowsSystem : public CL_System
{
public:
	CL_List<CL_Win32EventListener> listeners; // only to be used inside app_windows.cpp
	CL_List<CL_Win32KeepAlive> keep_alives; // only to be used inside app_windows.cpp

	CL_WindowsSystem();
	virtual ~CL_WindowsSystem();

	static HWND hWnd;
	static HINSTANCE hInstance;

 // only used by OpenGL, not DX impl:
	static HDC hDC;
	static HGLRC hRC;

	static CL_WindowsSystem *system;

	static void add_listener(CL_Win32EventListener *listener);
	static void remove_listener(CL_Win32EventListener *listener);

	static void add_keepalive(CL_Win32KeepAlive *keep_alive);
	static void remove_keepalive(CL_Win32KeepAlive *keep_alive);
};

class CL_Win32EventListener
{
public:
	virtual bool received_event(UINT uMsg, WPARAM wParam, LPARAM lParam)=0;
};

class CL_Win32KeepAlive
{
public:
	virtual bool keep_alive()=0;
};

#endif
