#include "Layer1/Display/DirectDraw/display_dx.h"
#include "Layer1/Sound/DirectSound/sound_dx.h"
#include "Layer1/NetWork/WinSockets/network_win32.h"
#include "implementation_directx.h"

#include "Layer1/Input/Win32/input_dx.h"

CL_Display_DX		*CL_Implementation_DirectX::ddraw = NULL;
CL_Sound_DX			*CL_Implementation_DirectX::dsound = NULL;
#ifdef USE_NETWORK
CL_Network_DX		*CL_Implementation_DirectX::dnetwork = NULL;
#endif
CL_Input_DX			*CL_Implementation_DirectX::dinput = NULL;

void CL_Implementation_DirectX::add_display(int options)
{
	ddraw = new CL_Display_DX(options);
	SetCursor(NULL);
	ShowCursor(FALSE);
}

void CL_Implementation_DirectX::add_sound()
{
	dsound = new CL_Sound_DX();
}

void CL_Implementation_DirectX::add_input()
{
	dinput = new CL_Input_DX;
}

void CL_Implementation_DirectX::add_network()
{
#ifdef USE_NETWORK
	dnetwork = new CL_Network_DX();
#endif
}

void CL_Implementation_DirectX::remove_display()
{
	delete ddraw;
	ddraw = NULL;
}

void CL_Implementation_DirectX::remove_sound()
{
	delete dsound;
	dsound = NULL;
}

void CL_Implementation_DirectX::remove_input()
{
	delete dinput;
	dinput = NULL;
}

void CL_Implementation_DirectX::remove_network()
{
#ifdef USE_NETWORK
	delete dnetwork;
	dnetwork = NULL;
#endif
}
