#include "../API/thread.h"
#include "thread_win32.h"

/*************************************
 Generic static create-thread function
*************************************/

CL_Thread *CL_Thread::create(void(*func)(void *))
{
	return new CL_Thread_Win32(func);
}

/*************************************
        class CL_Thread_Win32
*************************************/


CL_Thread_Win32::CL_Thread_Win32(void(*_func)(void *))
{
	func = _func;
}

CL_Thread_Win32::~CL_Thread_Win32()
{
}

unsigned long CL_Thread_Win32::func_proxy(void *arg)
{
	CL_Thread_Win32 *parent = (CL_Thread_Win32 *) arg;
	parent->func(parent->func_arg);

	return 0;
}

void CL_Thread_Win32::start(void *arg)
{
	func_arg = arg;
	thread_handle = CreateThread(NULL, 0, func_proxy, this, 0, &thread_id);
	if (thread_handle == NULL)
	{
		throw "Failed to create thread";
	}
}

void CL_Thread_Win32::terminate()
{
	TerminateThread(thread_handle, 0);
}
