/*
	$Id: timer_manager_win32.h,v 1.2 1998/12/22 00:59:07 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Provide ClanTimer support through Win32's multimedia timers.


	$Log: timer_manager_win32.h,v $
	Revision 1.2  1998/12/22 00:59:07  starch
	Fixed a gazillion include errors.
	
	Revision 1.1.1.1  1998/12/20 23:33:14  mbn
	ClanLib 0.1.10 development version importet.

	Revision 1.4  1998/09/17 12:06:39  mbn
	Converted all spaces to tabs by using unexpand.

	Revision 1.3	1998/04/24 11:54:57	 mbn
	Fixed include statements (General, Generic and API).

	Revision 1.2	1998/02/17 22:09:14	 mbn
	Changed class prefix to 'CL'.

	Revision 1.1.1.1	1998/02/07 16:51:18	 mbn
	Finally uploaded ClanLib-0.1.3 to CVS.

*/

#ifndef header_timermanager_win32
#define header_timermanager_win32

#include "Common/link.h"
#include "Layer1/System/API/timer_manager.h"

struct STimerInfo
{
	int callback_interval;
	int latest_timestamp;
	int reference_count;
	bool periodic;
	bool delete_pointer;
	float tolerance;
	CL_TimerCallback *callback_class;

	STimerInfo(int _callback_interval, float _tolerance, CL_TimerCallback *_callback_class, int _latest_timestamp, bool _periodic, bool _delete_pointer)
	{
		callback_interval = _callback_interval;
		latest_timestamp = _latest_timestamp;
		reference_count = 0;
		periodic = _periodic;
		callback_class = _callback_class;
		tolerance = _tolerance;
		delete_pointer = _delete_pointer;
	}

	~STimerInfo()
	{
		if (delete_pointer) delete callback_class;
	}
};

class CL_TimerManager_Win32 : public CL_TimerManager
{
public:
	static CL_List<STimerInfo> timer_info;

	static MMRESULT timer_handle;
	static int timer_idcount;
	static int granularity;
	static CL_TimerManager_Win32 *timermanager;

	CL_TimerManager_Win32();

	virtual ~CL_TimerManager_Win32();

	static void create_timer(int granularity, int tolerance);
	static void kill_timer();
	static int	greatest_common_div(int int1, int int2);
};

#endif
