/*
	$Id: inputbuffer_simple.h,v 1.1 1999/08/27 20:27:31 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l2_component="InputConverters"

#ifndef header_inputbuffer_simple
#define header_inputbuffer_simple

class CL_InputBuffer_Simple
//: Simplified inputbuffer.
// This is a simplified inputbuffer. It is nicer to use if you only want to
// read pressed keys.
{
public:
	CL_InputBuffer_Simple(CL_InputBuffer *buffer);
	virtual ~CL_InputBuffer_Simple();

	CL_Key peek_key();
	// Returns the next key in the buffer, but unlike get_key() it does not
	// pop it from the input buffer.

	CL_Key get_key();
	// Returns the next key in the buffer.

	int get_key_as_id();
	// Returns the next key in the buffer as key id.
	
	int get_key_as_ascii();
	// Returns the next key in the buffer in ascii format. -1 is returned
	// if the key doesn't have an ascii value.

	int keys_left();
	// Returns number of keys still available in the buffer.
	//!retval: Number of key values lefts in buffer.

	void clear();
	// Clears the buffer. After this, the buffer will not contain any keys.

private:
	void read_buffer();

	CL_InputBuffer *input_buffer;
	CL_Queue<CL_Key> keys;
};

#endif
