#ifndef header_netchannel_resource
#define header_netchannel_resource

//! l2_component="NetChannels"

#include "../../clanlib.h"

class CL_NetChannel_Resource : public CL_NetChannel
{
public:
	CL_NetChannel_Resource(int channel_num);
	CL_NetChannel_Resource(CL_NetComputer *server, int channel_num);
	virtual ~CL_NetChannel_Resource();

	void update_string_resource(const char *resource_id, const char *resource_string);
	void update_integer_resource(const char *resource_id, int resource_value);
	void update_float_resource(const char *resource_id, float resource_value);
	void update_data_resource(const char *resource_id, void *data, int size);

	void request_string_resource(const char *resource_id);
	void request_integer_resource(const char *resource_id);
	void request_float_resource(const char *resource_id);
	void request_data_resource(const char *resource_id);

	bool string_resource_received(const char *resource_id);
	bool integer_resource_received(const char *resource_id);
	bool float_resource_received(const char *resource_id);
	bool data_resource_received(const char *resource_id);
	
	CL_String get_string_resource(const char *resource_id);
	int get_integer_resource(const char *resource_id);
	float get_float_resource(const char *resource_id);
	void *get_data_resource(const char *resource_id, int *data_size);

	// Implementation of the CL_NetChannel Interface
	virtual int get_netchannel();
	virtual void receive(CL_NetComputer *from, CL_NetMessage *message);
	virtual bool is_secure();

private:
	int m_channel;

};




#endif