/*
	$Id: resourceoptions.h,v 1.1 1999/05/27 21:42:14 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l2_component="Resources"

#ifndef header_resourceoptions
#define header_resourceoptions

#include "../../Common/link.h"
#include "../../Common/clanstring.h"

class CL_ResourceManager;
class CL_ResourceOption;

class CL_ResourceOptions
{
public:
	CL_ResourceOptions(CL_ResourceManager *parent);
	~CL_ResourceOptions();
	
	CL_List<CL_ResourceOption> *get_options();

	bool read_options(const char *resource_name);
	CL_String get_value(CL_String option);
	CL_ResourceOption *get_option(CL_String option);
	bool exists(CL_String option);

private:
	CL_List<CL_ResourceOption> options;
	CL_ResourceManager *parent;
};

#endif
