/*
	$Id: resourcetype.h,v 1.1 1999/05/27 21:42:14 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l2_component="Resources"

#ifndef header_resourcetype
#define header_resourcetype

#include "../../Common/clanstring.h"
#include "../../Common/link.h"

class CL_ResourceManager;
class CL_ResourceOptions;
class CL_Resource;

class CL_ResourceType
{
public:
	CL_ResourceType(CL_String type_id);
	virtual ~CL_ResourceType();

	virtual CL_String get_typeid();
	virtual CL_Resource *try_create_from_file(
		CL_String name,
		CL_String prefix,
		CL_String res_id,
		CL_ResourceOptions *options,
		CL_ResourceManager *parent)=0;

	virtual CL_Resource *try_create_from_datafile(
		CL_String name,
		CL_String prefix,
		CL_String res_id,
		CL_ResourceOptions *options,
		CL_ResourceManager *parent)=0;

	static CL_List<CL_ResourceType> resource_types;

private:
	CL_String type_id;
};

#endif
