/*
	$Id: sprite_subarray_provider.h,v 1.6 1999/05/27 21:44:39 starch Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Subarray surface provider header file

*/

//! l2_component="SurfaceProviders"

#ifndef header_sprite_subarray_provider
#define header_sprite_subarray_provider

#include "../../clanlib.h"
#include "generic_surfaceprovider.h"

class CL_SpriteSubarrayProvider : public CL_SurfaceProvider_Generic
{
	CL_SurfaceProvider *parent_provider;
	bool locked;
	int start_x, start_y;
	int width, height;
	int array_width, array_height;
	unsigned char *surface_data;
public:
	static CL_Surface *create(CL_SurfaceProvider *parent_provider, int start_x, int start_y, int width, int height, int array_width, int array_height);

	CL_SpriteSubarrayProvider(CL_SurfaceProvider *parent_provider, int start_x, int start_y, int width, int height, int array_width, int array_height);
	virtual ~CL_SpriteSubarrayProvider();

	virtual int get_pitch() const;
	virtual int get_translate_x() const;
	virtual int get_translate_y() const;
	virtual int get_width() const;
	virtual int get_height() const;
	virtual int get_no_sprs() const;
	virtual EPixelFormat get_pixel_format() const;
	virtual CL_Palette *get_palette() const;
	virtual int get_transcol() const;
	
	virtual void *get_surface_data() const;

	virtual void perform_lock();
	virtual void perform_unlock();
};

#endif
