/*
	$Id: cvsstrip.cpp,v 1.2 1998/12/22 06:35:56 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Converts from dos text format to unix text format.

*/


#include <stdio.h>
#include <iostream.h>
#include <stdio.h>
#include <dirent.h>

#include "../Common/link.h"
#include "../Common/clanstring.h"

void scan_directory(const char *path);
void strip_file(const char *file);

void main()
{
	cout << "dos->unix text converter. Copyright (c)1998 ClanSoft." << endl << endl;

	cout << "stripping all .cpp; .h; .scr; .asm; .c files..." << endl;
	cout << "---" << endl;
	scan_directory(".");
}

void scan_directory(const char *path)
{
//	cout << "Scanning directory " << path << endl;

	DIR *dir = opendir(path);
	dirent *fileinfo = readdir(dir);

	while (fileinfo != NULL)
	{
		CL_String filename(fileinfo->d_name);
		CL_String fullpath = CL_String(path, "/")+filename;

		DIR *dir2 = opendir(fullpath);
		if (dir2 != NULL) closedir(dir2);

		if (dir2 != NULL)
		{
			if (filename != "." && filename != "..") scan_directory(fullpath);
		}
		else
		{
			if (filename.right(4)==".cpp" ||
				filename.right(2)==".h" ||
				filename.right(2)==".c" ||
				filename.right(4)==".scr" ||
				filename.right(4)==".asm" ||
				filename == "Makefile" ||
				filename == "README" ||
				filename == "COPYING" ||
				filename == "Makefile.conf" ||
				filename == "Makefile.conf.in" ||
				filename == "Makefile.dep" ||
				filename == "Makefile.dep.in")
			{
				strip_file(fullpath);
			}
		}

		fileinfo = readdir(dir);
	}

	if (dir != NULL) closedir(dir);
}

void strip_file(const char *file)
{
//	cout << "Checking file " << file << endl;

	unsigned long size = 1024*1024;

	unsigned char *from = new unsigned char[size];
	unsigned char *to = new unsigned char[size];

	FILE *in = fopen(file, "rb");
	size = fread(from, 1, size, in);
	fclose(in);

	int to_size = 0;

	for (unsigned int pos=0; pos<size; pos++)
	{
		if (from[pos] == 13) continue; // strip char-13

		to[to_size] = from[pos];
		to_size++;
	}

	if (size != to_size)
	{
		FILE *out = fopen(file, "wb");
		fwrite(to, to_size, 1, out);
		fclose(out);

		cout << "Stripped " << file << endl;
	}

	delete[] from;
	delete[] to;
}
