%define version 0.1.19
%define release 1
%define prefix /usr

Summary: The ClanLib Game SDK.
Name: ClanLib-Static-X11
Version: %{version}
Release: %{release}
Copyright: LGPL
Group: Development/Libraries
BuildRoot: /tmp/clanlib-root
Source: ClanLib-Static-X11-%{version}.tar.gz
URL: http://clanlib.org
Provides: ClanLib %{version}

%description
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. The goal is to provide a common interface to
classical game problems (loading graphics eg.), so games can share as much
code as possible. Ideally anyone with small resources should be able to
write commercial quality games.

This is a static X11 RPM package. Try it if the dynamic loadable version
doesn't work on your system.

%prep
%setup

%build
CXXFLAGS="-O6 -mpentium -malign-loops=2 -malign-functions=2 -malign-jumps=2 -fomit-frame-pointer"
CFLAGS="-O6 -mpentium -malign-loops=2 -malign-functions=2 -malign-jumps=2 -fomit-frame-pointer"
./configure --prefix=%prefix --disable-glx --disable-ptc --disable-svgalib --disable-fbdev --disable-ggi
make -j 4
make strip

%install
make prefix=$RPM_BUILD_ROOT%{prefix} install

%post
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc README* COPYING CREDITS ChangeLog
%{prefix}/lib/libclan.so*
%{prefix}/lib/libclancommon.so*
%{prefix}/lib/libclanlayer1.so*
%{prefix}/lib/libclanlayer2.so*
