/*
	 $Id: clanlib.h,v 1.23 1999/09/02 10:58:31 vogel Exp $

	 ------------------------------------------------------------------------
	 ClanLib, the platform independent game SDK.

	 This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	 version 2. See COPYING for details.

	 For a total list of contributers see CREDITS.

	 ------------------------------------------------------------------------

	 File purpose:
	 General include file for the ClanLib layer1.

 */

#ifndef header_clanlib
#define header_clanlib

#include <stdlib.h>

#define CL_VERSION(x,y,z)	( (x << 16) | (y << 8) | (z) )
#define CL_CURRENT_VERSION	CL_VERSION(0,1,19)
#define CL_VERSION_STRING "0.1.19"
#define CL_RELEASE_NAME "Ripping your eyes out with a spoon"

#ifdef WIN32
#pragma warning( disable : 4786)
#endif

#include "Common/memory.h"

#include "Common/array.h"
#include "Common/clanstring.h"
#include "Common/error.h"
#include "Common/formatted_data.h"
#include "Common/link.h"
#include "Common/queue.h"
#include "Common/matrix.h"
#include "Common/stack.h"
#include "Common/vector.h"
#include "Common/bezier.h"
#include "Common/hashtable.h"

#include "Layer1/Display/API/display.h"
#include "Layer1/Display/API/vidmode.h"
#include "Layer1/Display/API/displaycard.h"
#include "Layer1/Display/API/surfacepriority.h"
#include "Layer1/Display/API/surface.h"
#include "Layer1/Display/API/palette.h"
#include "Layer1/Display/API/pixelformat.h"
#include "Layer1/Display/API/surfaceprovider.h"
#include "Layer1/Display/API/lockable_surface.h"

#include "Layer1/Sound/API/sound.h"
#include "Layer1/Sound/API/soundformat.h"
#include "Layer1/Sound/API/static_soundprovider.h"
#include "Layer1/Sound/API/stream_soundprovider.h"
#include "Layer1/Sound/API/soundbuffer_session.h"
#include "Layer1/Sound/API/soundbuffer.h"

#include "Layer1/Input/API/input.h"
#include "Layer1/Input/API/inputbutton.h"
#include "Layer1/Input/API/inputaxis.h"
#include "Layer1/Input/API/inputhat.h"
#include "Layer1/Input/API/inputcursor.h"
#include "Layer1/Input/API/inputbuffer.h"
#include "Layer1/Input/API/inputdevice.h"
#include "Layer1/Input/API/keyboard.h"
#include "Layer1/Input/API/mouse.h"

#include "Layer1/Network/API/network.h"
#include "Layer1/Network/API/netcomputer.h"
#include "Layer1/Network/API/netgroup.h"
#include "Layer1/Network/API/netmessage.h"
#include "Layer1/Network/API/netgame.h"

#include "Layer1/System/API/clanapp.h"
#include "Layer1/System/API/system.h"
#include "Layer1/System/API/timer_manager.h"
#include "Layer1/System/API/cl_assert.h"
#include "Layer1/System/API/error.h"
#include "Layer1/System/API/settings.h"
#include "Layer1/System/API/thread.h"
#include "Layer1/System/API/mutex.h"

#include "Layer1/IOData/API/cl_endian.h"
#include "Layer1/IOData/API/inputsource.h"
#include "Layer1/IOData/API/inputsource_provider.h"
#include "Layer1/IOData/API/outputsource.h"
#include "Layer1/IOData/API/outputsource_provider.h"

#endif

