%define version 0.1.19
%define release 1
%define prefix /usr

Summary: The ClanLib Game SDK.
Name: ClanLib
Version: %{version}
Release: %{release}
Copyright: LGPL
Group: Development/Libraries
BuildRoot: /tmp/clanlib-root
Source: ClanLib-%{version}.tar.gz
URL: http://clanlib.org

# --------------------- MANUAL REQUIRES CODE ---------------------------

# Must add requires for ClanLib manually (ldd libclan.so). :-(
# (why isn't it possible to ask rpm to check a _limited_ range of
# executables???)
Requires: Hermes >= 1.2.4, zlib

# Disable RPM's automatic dependency checks.
# This conflicts with our dynamic linking code because it detects that
# libclan-display-ptc.so for instance requires OpenPTC, but our package
# does not require openptc -- It will just take advantage of it if its
# there.
AutoReqProv: No

Provides: libclan.so, libclan.so.0, libclan.so.%{release}, libclanlayer1.so.0, libclanlayer1.so.%{release}, libclanlayer2.so, libclanlayer2.so.0, libclanlayer2.so.%{release}, libclancommon.so, libclancommon.so.0, libclancommon.so.%{release}

# ----------------------------------------------------------------------

%description
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. The goal is to provide a common interface to
classical game problems (loading graphics eg.), so games can share as much
code as possible. Ideally anyone with small resources should be able to
write commercial quality games.

%package devel
Summary: ClanLib include files for developers
Group: Development/Libraries

# ---
Requires: ClanLib
AutoReqProv: No
# ---

%description devel
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. The goal is to provide a common interface to
classical game problems (loading graphics eg.), so games can share as much
code as possible. Ideally anyone with small resources should be able to
write commercial quality games.

This part of the archive includes the files necessary for developers. This
includes:
 Header files.
 The Datafile compiler.

%package docs
Summary: ClanLib documentation
Group: Development/Libraries

%description docs
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. The goal is to provide a common interface to
classical game problems (loading graphics eg.), so games can share as much
code as possible. Ideally anyone with small resources should be able to
write commercial quality games.

This part contains the documentation. At the moment this includes:
 Unix manual page reference documentation.
 HTML format reference documentation.

%prep
%setup

%build
CXXFLAGS="-O6 -mpentium -malign-loops=2 -malign-functions=2 -malign-jumps=2 -fomit-frame-pointer"
CFLAGS="-O6 -mpentium -malign-loops=2 -malign-functions=2 -malign-jumps=2 -fomit-frame-pointer"
./configure --prefix=%prefix --enable-mesa --enable-dyn --disable-ptc
make
make strip
make docs

%install
make prefix=$RPM_BUILD_ROOT%{prefix} install
make prefix=$RPM_BUILD_ROOT%{prefix} docs_install

%post
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc README* COPYING CREDITS ChangeLog
%{prefix}/lib/libclan.so*
%{prefix}/lib/libclancommon.so*
%{prefix}/lib/libclanlayer1.so*
%{prefix}/lib/libclanlayer2.so*
%{prefix}/lib/ClanLib/*

%files devel
%defattr(-, root, root)
%{prefix}/bin/datafile_compiler
%{prefix}/include/ClanLib/*

%files docs
%defattr(-, root, root)
%{prefix}/doc/ClanLib-docs-%{version}/*
%{prefix}/man/man1/datafile_compiler.1
%{prefix}/man/man3/CL*
%{prefix}/man/man3/clanlib.3
