.\"
.\" GLE Tubing & Extrusions Library Documentation 
.\"
.TH gleScrew 3GLE "3.6" "GLE" "GLE"
.SH NAME
gleScrew - Draws screw-type shapes.
.SH SYNTAX
.nf
.LP
void gleScrew (int ncp,
               gleDouble contour[][2],
               gleDouble cont_normal[][2],
               gleDouble up[3],
	       gleDouble startz,
	       gleDouble endz,
	       gleDouble twist);
.fi
.SH ARGUMENTS
.IP \fIncp\fP 1i
number of contour points
.IP \fIcontour\fP 1i
2D contour
.IP \fIcont_normal\fP 1i
2D contour normals
.IP \fIup\fP 1i
up vector for contour
.IP \fIstartx\fP 1i
start of segment
.IP \fIendz\fP 1i
end of segment
.IP \fItwist\fP 1i
number of rotations
.SH DESCRIPTION

Draws screw-type shapes. Takes a contour, and extrudes it along the
z-axis, from a start z value of startz to an end z-value of endz.
During the extrusion, it will spin the contour along the contour origin
by twist degrees.

.SH SEE ALSO
gleExtrusion
.SH AUTHOR
Linas Vepstas (linas@fc.net)
