
#include "puLocal.h"

/*
  A set of puFont's to implement the GLUT BitMap set...
*/

puFont PUFONT_8_BY_13        ( GLUT_BITMAP_8_BY_13        ) ;
puFont PUFONT_9_BY_15        ( GLUT_BITMAP_9_BY_15        ) ;
puFont PUFONT_TIMES_ROMAN_10 ( GLUT_BITMAP_TIMES_ROMAN_10 ) ;
puFont PUFONT_TIMES_ROMAN_24 ( GLUT_BITMAP_TIMES_ROMAN_24 ) ;
puFont PUFONT_HELVETICA_10   ( GLUT_BITMAP_HELVETICA_10   ) ;
puFont PUFONT_HELVETICA_12   ( GLUT_BITMAP_HELVETICA_12   ) ;
puFont PUFONT_HELVETICA_18   ( GLUT_BITMAP_HELVETICA_18   ) ;



int puFont::getStringWidth ( char *str )
{
  if ( str == NULL )
    return 0 ;

  if ( glut_font_handle != NULL )
  {
    int res = 0 ;

    while ( *str != '\0' )
    {
      res += glutBitmapWidth ( glut_font_handle, *str ) ;
      str++ ;
    }

    return res ;
  }

  if ( fnt_font_handle != NULL )
  {
    float r, l ;
    fnt_font_handle -> getBBox ( str, pointsize, slant, &l, &r, NULL, NULL ) ;
    return (int) ( r - l ) ;
  }

  return 0 ;
}


int puFont::getStringHeight ()
{
  /* Height *excluding* descender */
   
  if ( glut_font_handle != NULL )
  {
    if ( glut_font_handle == GLUT_BITMAP_8_BY_13        ) return  9 ;
    if ( glut_font_handle == GLUT_BITMAP_9_BY_15        ) return 10 ;
    if ( glut_font_handle == GLUT_BITMAP_TIMES_ROMAN_10 ) return  7 ;
    if ( glut_font_handle == GLUT_BITMAP_TIMES_ROMAN_24 ) return 17 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_10   ) return  8 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_12   ) return  9 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_18   ) return 14 ;
    return 0 ;
  }

  if ( fnt_font_handle != NULL )
  {
    float t, b ;
    fnt_font_handle -> getBBox ( "K", pointsize, slant, NULL, NULL, &b, &t ) ;
    return (int) ( t - b ) ;
  }

  return 0 ;
}


int puFont::getStringDescender ()
{
  if ( glut_font_handle != NULL )
  {
    if ( glut_font_handle == GLUT_BITMAP_8_BY_13        ) return 2 ;
    if ( glut_font_handle == GLUT_BITMAP_9_BY_15        ) return 3 ;
    if ( glut_font_handle == GLUT_BITMAP_TIMES_ROMAN_10 ) return 2 ;
    if ( glut_font_handle == GLUT_BITMAP_TIMES_ROMAN_24 ) return 5 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_10   ) return 2 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_12   ) return 3 ;
    if ( glut_font_handle == GLUT_BITMAP_HELVETICA_18   ) return 4 ;
    return 0 ;
  }

  if ( fnt_font_handle != NULL )
  {
    float b ;
    fnt_font_handle -> getBBox ( "y", pointsize, slant, NULL, NULL, &b, NULL ) ;
    return (int) -b ;
  }

  return 0 ;
}


void puFont::drawString ( char *str, int x, int y )
{
  if ( str == NULL )
    return ;

  if ( glut_font_handle != NULL )
  {
    glRasterPos2f( (float)x, (float)y ) ; 

    while ( *str != '\0' )
    {
      glutBitmapCharacter ( glut_font_handle, *str ) ;
      str++ ;
    }
    return ;
  }

  if ( fnt_font_handle != NULL )
  {
    sgVec3 curpos ;
    sgSetVec3 ( curpos, (float)x, (float)y, 0.0f ) ;

    glEnable    ( GL_ALPHA_TEST   ) ;
    glEnable    ( GL_BLEND        ) ;
    glAlphaFunc ( GL_GREATER, 0.1 ) ;
    glBlendFunc ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA ) ;

    fnt_font_handle -> begin () ;
      fnt_font_handle -> puts ( curpos, pointsize, slant, str ) ;
    fnt_font_handle -> end () ;

    glDisable ( GL_ALPHA_TEST ) ;
    glDisable ( GL_BLEND      ) ;
    glDisable ( GL_TEXTURE_2D ) ;
    return ;
  }
}


