////////////////////////////////////////////////////////
//
// drawStereo
//
// mdanks@cybermed.ucsd.edu
//
// Implementation file
//
//    Copyright (c) 1998 Mark Danks.
//    For information on usage and redistribution, and for a DISCLAIMER OF ALL
//    WARRANTIES, see the file, "LICENSE.TERMS" in this distribution.
//
/////////////////////////////////////////////////////////

#include "EventHandlerWin.h"
#include "EventProc.h"

#include <iostream.h>

/////////////////////////////////////////////////////////
// MainWndProc
//
/////////////////////////////////////////////////////////
LONG WINAPI MainWndProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	// assume that we handle the message
    long lRet = 0;
    switch (uMsg)
    {
        // mouse motion
        case WM_MOUSEMOVE:
            triggerMotionEvent(LOWORD(lParam), HIWORD(lParam), .5f, hWnd);
            break;

        // left button up
        case WM_LBUTTONUP:
            triggerButtonEvent(0, 0, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // left button down
        case WM_LBUTTONDOWN:
            triggerButtonEvent(0, 1, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // middle button up
        case WM_MBUTTONUP:
            triggerButtonEvent(1, 0, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // middle button down
        case WM_MBUTTONDOWN:
            triggerButtonEvent(1, 1, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // right button up
        case WM_RBUTTONUP:
            triggerButtonEvent(2, 0, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // right button down
        case WM_RBUTTONDOWN:
            triggerButtonEvent(2, 1, LOWORD(lParam), HIWORD(lParam), hWnd);
            break;

        // keyboard action
        case WM_KEYUP:
            triggerKeyboardEvent((int)wParam, 1, hWnd);
            break;

        // keyboard action
        case WM_KEYDOWN:
            triggerKeyboardEvent((int)wParam, 0, hWnd);
            break;

        // resize event
        case WM_SIZE:
            triggerResizeEvent(LOWORD(lParam), HIWORD(lParam), hWnd);
		    break;

        // close event
   	    case WM_DESTROY:
       	case WM_CLOSE:
            triggerCloseEvent(hWnd);
		    break;

        // pass all unhandled messages to DefWindowProc
        default:
            lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
            break;
    }
    return(lRet);
}

