
#include "ssgLocal.h"

ssgList::ssgList ( int parent_list, int init )
{
  i_am_a_parent_list = parent_list ;
  total = 0 ;
  entity_list = new ssgEntity * [ limit = (init <= 0) ? 1 : init ] ;
}


ssgList::~ssgList (void)
{
  /* Don't remove parent nodes - just dereference them. */

  if ( i_am_a_parent_list )
  {
    for ( unsigned int i = 0 ; i < total ; i++ )
      entity_list [ i ] -> deRef () ;
  }
  else
    removeAllEntities () ;

  delete entity_list ;
}


void ssgList::addEntity ( ssgEntity *entity )
{
  entity->ref() ;
  sizeChk () ;
  entity_list [ total++ ] = entity ;
}

void ssgList::sizeChk (void)
{
  /* Room for one more Entity? */

  if ( total >= limit )
  {
    limit += limit ;
    ssgEntity **nlist = new ssgEntity * [ limit ] ;
    memmove ( nlist, entity_list, sizeof(ssgEntity *) * total ) ;
    delete entity_list ;
    entity_list = nlist ;
  }
}


int ssgList::searchForEntity ( ssgEntity *entity )
{
  for ( unsigned int i = 0 ; i < total ; i++ )
    if ( entity_list [ i ] == entity )
      return (int) i ;

  return -1 ;
}


void ssgList::removeAllEntities ()
{
  while ( total > 0 )
    removeEntity ( (unsigned int) 0 ) ;
}

void ssgList::removeEntity ( unsigned int n )
{
  ssgEntity *e = entity_list [ n ] ;

  memmove ( &(entity_list[n]), &(entity_list[n+1]), sizeof(ssgEntity *) * (total-n-1) ) ;
  total-- ;

  if ( next >= n )
    next-- ;

  e -> deRef () ;

  if ( ! i_am_a_parent_list && e -> getRef () == 0 )
    delete e ;
}


