/*
	$Id: input.h,v 1.4 1999/04/24 17:09:28 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l1_component="Input"

#ifndef header_input
#define header_input

#include "../../../Common/array.h"

class CL_InputDevice;
class CL_Keyboard;

class CL_Input
//: Input component class.
// CL_Input is the access point to keyboards, joysticks and pointers.
{
public:
	virtual ~CL_Input() { return; }

	static CL_Array<CL_Keyboard> keyboards;
	//: List of keyboards available.
	
	static CL_Array<CL_InputDevice> joysticks; // joysticks and gamepads
	//: List of joysticks and gamepads available.
	
	static CL_Array<CL_InputDevice> pointers; // mice and digitizers
	//: List of mice and digitizers available.
};

#endif
