/*
	$Id: mutex.h,v 1.1 1999/08/14 22:48:25 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_mutex
#define header_mutex

class CL_Mutex
{
public:
	static CL_Mutex *create();

	virtual ~CL_Mutex() { ; }
	
	virtual void enter()=0;
	virtual void leave()=0;
};

class CL_MutexSection
{
public:
	CL_MutexSection(CL_Mutex *mutex)
	{
		this->mutex = mutex;
		mutex->enter();
	}

	virtual ~CL_MutexSection()
	{
		mutex->leave();
	}

private:
	CL_Mutex *mutex;
};

#endif
