/*
	$Id: inputaxis_group.h,v 1.4 1999/05/28 12:38:27 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l2_component="InputConverters"

#ifndef header_inputaxis_group
#define header_inputaxis_group

class CL_InputAxis_Group : public CL_InputAxis
//: CL_InputAxis container class. Groups a set of axes.
{
	CL_List<CL_InputAxis> axes;
public:
	void add(CL_InputAxis *add_axis)
	{
		axes.add(add_axis);
	}
	//: Adds a input axis to the group.
	//!param: add_axis - Axis to be added.

	void remove(CL_InputAxis *remove_axis)
	{
		axes.del(remove_axis);
	}
	//: Removes a input axis from the group.
	//!param: remove_axis - Axis to be removed.

	virtual float get_pos()
	{
		float pos = 0;

		CL_Iterator<CL_InputAxis> counter(axes);
		while (counter.next() != NULL)
		{
			pos += counter()->get_pos();
		}

		if (pos > 1) pos = 1;
		if (pos < -1) pos = -1;

		return pos;
	}
	//: Returns the current axis position. This is calculated by sumarizing
	//: all the input axes positions and return that value.
	//!retval: Current axis position.
};

#endif
