/*
	$Id: netobject_creator.h,v 1.1 1999/09/02 11:25:49 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! l2_component="NetChannels"

#ifndef header_netobject_creator
#define header_netobject_creator

#include "netobject.h"

class CL_NetObjectCreator
//: NetObject creation interface.
// CL_NetObjectCreator is used by CL_NetObjectController_Basic to create a
// new slave netobject based on its type ID and a creation packet.
//
// Inherit and implement this class to use the netobjects.
{
public:
	virtual ~CL_NetObjectCreator() {};

	virtual CL_NetObject *create(int type, CL_InputSource *input)=0;
};

class CL_NetDataCreator
//: NetDataObject creation interface.
// CL_NetDataCreator is used by CL_NetDataController to create a
// new slave netobject based on its type ID and a creation packet.
//
// Inherit and implement this class to use the netobjects.
{
public:
	virtual ~CL_NetDataCreator() {};

	virtual CL_NetDataObject *create_data(int type, int size)=0;
};

#endif
