/*
	$Id: resourceoption.h,v 1.2 1999/08/23 18:41:45 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_resourceoption
#define header_resourceoption

class CL_ResourceOption
{
public:
	CL_ResourceOption(CL_String _name, CL_String _value)
	{
		name = _name;
		value = _value;
		has_value = true;
		multiple_values = false;
		values = NULL;
	}

	CL_ResourceOption(CL_String _name, CL_List<CL_String> *_values)
	{
		name = _name;
		values = _values;
		value = (values->get_item(0) != NULL) ? (*values->get_item(0)) : CL_String("");
		multiple_values = true;
		has_value = true;
	}

	CL_ResourceOption(CL_String _name)
	{
		name = _name;
		has_value = false;
		multiple_values = false;
		values = NULL;
	}

	virtual ~CL_ResourceOption()
	{
		if (values != NULL)
		{
			CL_Iterator<CL_String> cleanup(values);
			while (cleanup.next()!=NULL) delete cleanup();
			delete values;
		}
	}

	bool multi_valued() { return multiple_values; }
	CL_List<CL_String> *get_all_values() { return values; }

	CL_String get_name() { return name; }
	CL_String get_value()
	{
		if (has_value) return value;
		else return CL_String("NO VALUE");
	}
	
private:
	CL_String name;
	CL_String value;
	CL_List<CL_String> *values;
	bool has_value;
	bool multiple_values;
};

#endif
