/*
	 $Id: clanlayer2.h,v 1.16 1999/09/02 11:25:48 sphair Exp $

	 ------------------------------------------------------------------------
	 ClanLib, the platform independent game SDK.

	 This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	 version 2. See COPYING for details.

	 For a total list of contributers see CREDITS.

	 ------------------------------------------------------------------------

	 File purpose:
	 General include file for the ClanLib layer2.

 */

#ifndef header_clanlayer2
#define header_clanlayer2

#include "clanlib.h"

#include "Layer2/SurfaceProviders/provider_convpoly_basics.h"
#include "Layer2/SurfaceProviders/provider_convpoly.h"
#include "Layer2/SurfaceProviders/provider_empty.h"
#include "Layer2/SurfaceProviders/provider_fli.h"
#include "Layer2/SurfaceProviders/provider_pcx.h"
#include "Layer2/SurfaceProviders/provider_png.h"
#include "Layer2/SurfaceProviders/provider_targa.h"
#include "Layer2/SurfaceProviders/sprite.h"
#include "Layer2/SurfaceProviders/sprite_subarray_provider.h"
#include "Layer2/SurfaceProviders/sprite_subsection_provider.h"
#include "Layer2/SurfaceProviders/surface_manager.h"
#include "Layer2/StaticSoundProviders/wave_sample.h"
#include "Layer2/StaticSoundProviders/raw_sample.h"
#include "Layer2/StreamSoundProviders/streamed_wave_sample.h"
#include "Layer2/StreamSoundProviders/streamed_raw_sample.h"
#include "Layer2/StreamSoundProviders/mikmod/streamed_mikmod_sample.h"
#include "Layer2/InputConverters/inputaxis_basic.h"
#include "Layer2/InputConverters/inputbuffer_simple.h"
#include "Layer2/InputConverters/inputbutton_basic.h"
#include "Layer2/InputConverters/inputbutton_group.h"
#include "Layer2/InputConverters/inputaxis_group.h"
#include "Layer2/InputConverters/inputbutton_to_axis_analog.h"
#include "Layer2/InputConverters/inputbutton_to_axis_digital.h"
#include "Layer2/Misc/font.h"
#include "Layer2/Misc/cltime.h"
#include "Layer2/Misc/menu.h"
#include "Layer2/Misc/layermanager.h"
#include "Layer2/Misc/inputsource_memory.h"
#include "Layer2/Misc/outputsource_memory.h"
#include "Layer2/NetChannels/netobject.h"
#include "Layer2/NetChannels/netobject_creator.h"
#include "Layer2/NetChannels/netobject_controller_basic.h"
#include "Layer2/NetChannels/netdata_controller.h"
#include "Layer2/Resources/resource_manager.h"
#include "Layer2/Resources/resourcetype_font.h"
#include "Layer2/Resources/resourcetype_palette.h"
#include "Layer2/Resources/resourcetype_sample.h"
#include "Layer2/Resources/resourcetype_surface.h"
#include "Layer2/Resources/resourcetype_raw.h"
#include "Layer2/Resources/resourcetype_integer.h"
#include "Layer2/Resources/resourcetype_string.h"
#include "Layer2/Resources/resourcetype_boolean.h"

#endif
